import re
iteration_re = re.compile(r"Attempt ([0-9]+)")
error_re = re.compile(r"Bisect FAILED|Warning: ")

def parse_log_witness_bounds(path):
    records = []
    with open(path, 'rt') as f:
        attempt = -1
        for line in f:
            m_iter = iteration_re.search(line)
            if m_iter is not None:
                new_i = int(m_iter.group(1))
                if new_i != attempt + 1:
                    raise RuntimeError(f'expected attempt {attempt+1} but found "{m_iter.group(1)}"')
                attempt = new_i
                records.append(True)
            m_err = error_re.search(line)
            if m_err is not None:
                records[-1] = False
    return records

